//	DISPLAY OF EMERALDS
//	Scripted by AceLite
//	Contributed from Sonic Adventure Style Pack
//

local emerald = {EMERALD1, EMERALD2, EMERALD3, EMERALD4, EMERALD5, EMERALD6, EMERALD7}
local emerald_max = EMERALD1|EMERALD2|EMERALD3|EMERALD4|EMERALD5|EMERALD6|EMERALD7

local circle_bool = false
local circle_scale = 0
local circle_split = (360/#emerald)*ANG1
local circle_size = 34
local circle_timing = FRACUNIT/10
local circle_start = -(FRACUNIT << 1)
local circle_end = FRACUNIT << 1

local em_x = (151+8) << FRACBITS -- base+new_offset
local em_y = (78+9) << FRACBITS -- base+new_offset
local em_s = FRACUNIT*(3/2)

local bem_x = 200 << FRACBITS
local bem_y = 9 << FRACBITS
local bem_s = FRACUNIT >> 1

-- random rotating rocks + add there damn 8th Peaceful Ruby.
hud.add(function(v)
	local p = displayplayer
	if multiplayer then
		hud.enable("coopemeralds")
		if mrce.hyperunlocked or p.mrce and p.mrce.hypercheat then
			v.drawScaled(bem_x, bem_y, bem_s, v.cachePatch("CHAOS8"))
		end
	else
		hud.disable("coopemeralds")
		circle_scale = min(ease.linear(circle_timing, circle_scale, circle_end), FRACUNIT)
		circle_bool = true
	end
end, "scores")

-- random rotating rocks + add there damn 8th Peaceful Ruby.
hud.add(function(v)
	if circle_scale then
		local p = displayplayer
	
		//Off loading local variables for optimalization purposes
		local leveltime_ang = ANGLE_225 + (emerald_max & emeralds and leveltime*ANG1 or 0)

		-- Vanilla Emeralds
		for id,k in ipairs(emerald) do
			// IF check compares from table whenever or not emerald is in player's possession
			if emeralds & k then
				local pos_ang = id*circle_split + leveltime_ang

				local patch = v.cachePatch("CENTCHAOS"..id)
				v.drawScaled(
				(circle_size * cos(pos_ang)) + em_x, 
				(circle_size * sin(pos_ang)) + em_y, 
				circle_scale, patch)
			end
		end

		-- "Master Emerald"
		if mrce.hyperunlocked or (p.mrce and p.mrce.hypercheat and not p.bot) then
			v.drawScaled(em_x, em_y, FixedMul(em_s, circle_scale), v.cachePatch("CENTCHAOS8"))
		end
		
		if not circle_bool then
			circle_scale = max(ease.linear(circle_timing, circle_scale, circle_start), 0)		
		end
		
		circle_bool = false
	end
end, "game")
